﻿using System;
using System.Diagnostics;

namespace CV7
{
    class Program
    {
        [Conditional("DEBUG")]
        static void SomeFunctionThatHasToRunUnderDebugOnly()
        {
            Console.WriteLine("I'm in debug!");
        }

        static void Main(string[] args)
        {
            Debug.Listeners.Add(new TextWriterTraceListener(Console.Out));

            Debug.WriteLine("Start of the program.");
            Debug.Indent();
            Debug.WriteLine("Indented text.");
            Debug.Unindent();
            Debug.WriteLine("Let's go");

            Console.Write("Write something: ");
            string input = Console.ReadLine();

            Trace.WriteLineIf(input == "OK", "Input is OK");
            Trace.Assert(input == "OK", "Input is not OK.");

            if (input != "OK")
                Trace.Fail("Input is really not OK.");

            SomeFunctionThatHasToRunUnderDebugOnly();
        }
    }
}
