﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading;

namespace CV7Service
{
    public partial class Service1 : ServiceBase
    {
        private Timer timer;
        private string path;
        private PerformanceCounter cpuCounter;

        public Service1()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            path = ConfigurationManager.AppSettings["path"];
            int interval = Convert.ToInt32(ConfigurationManager.AppSettings["interval"]);

            cpuCounter = new PerformanceCounter();
            cpuCounter.CategoryName = "Processor";
            cpuCounter.CounterName = "% Processor Time";
            cpuCounter.InstanceName = "_Total";

            timer = new Timer(LogCPU, null, 0, interval);

            WriteToFile("Service start");
        }

        protected override void OnStop()
        {
            WriteToFile("Service stop");
        }

        private void LogCPU(object o)
        {
            WriteToFile(cpuCounter.NextValue() + " %");
        }

        private void WriteToFile(string message)
        {
            File.AppendAllText(path, message + Environment.NewLine);
        }
    }
}
